#ifndef	__ADC_HPP__
#define 	__ADC_HPP__

#include  <iom128.h>

//	     SMHLogix
#define 	LOGIX_MAXADC_CHANELS	6

//	 
#define 	ADC_FILTRMAXORDER	16
#define 	REFADC_EXT			0x00
#define 	REFADC_AVCC			0x01
#define 	REFADC_RESERVED	0x02
#define 	REFADC_INT			0x03
#define 	REFADC_MASK			0x03
#define 	REFADC_BITS			6

#ifndef	REFS1
#define	REFS1	7
#endif
#ifndef	REFS0
#define	REFS0	6
#endif

#define 	REFADC_INT_NOM		2.56
#define 	REFADC_EXT_NOM		2.50
#define 	REFADC_AVCC_NOM	5.00
#define 	ADC_SCALE_FACTOR	30.0

//**************************************************************************************
class ClassADCChanels {
  private:
    volatile            char  order;        	//    -  
    volatile            char  sample_cntr;  	//    
    volatile            bool  filter_on;
    volatile            int   *buffer;      	//      ADC
    volatile	signed	char  Kcntr;
    volatile				bool	Kflag;
  public:
  								float	K;					//	  y = Kx (+ B)
    volatile  unsigned  char  Mux;          	//     ADMUX
    ClassADCChanels           *Next;
    //---------------------------------------------------------------------------------
    ClassADCChanels(unsigned  char num) : filter_on(true),	Kflag(false)	{
    	Mux = num & ~((REFADC_INT << REFADC_BITS) | (1 << ADLAR));
    	if((Mux	> 0x07) && (Mux < 0x1E))	Mux |= (1 << ADLAR);
#ifndef	__SMH2010_C__
    	Mux |= (REFADC_INT << REFADC_BITS);
#endif
      order       = 	ADC_FILTRMAXORDER;
      sample_cntr = 	0;
      K				=	1.0;
      Next        = 	this;
      }
    //---------------------------------------------------------------------------------
    inline	char	isDiff(void)	{
    	if((Mux & ~(REFADC_MASK << REFADC_BITS)) > 0x07)	return	0x01;
    	return	0x00;
    	}
    //---------------------------------------------------------------------------------
    void	Correct(float etalon_volt)	{
    	unsigned	char	_mux,sreg;
					bool	_filter;
    				int	volue;
    				float	etalon,fvolue;

    	Kcntr	=	order;
    	//	     
    	_mux	=	Mux & ~((1 << REFS1) | (1 << REFS0) | (1 << ADLAR));
    	if(_mux > 0x07)	{
    		etalon	=	512.0;
    		if(0x10 > _mux)	{
    			if(_mux & 0x02)	etalon	*=	200.0;
    			else					etalon	*=	10.0;
    			}
    		}
    	else	etalon	=	1024.0;

    	//	 
    	_mux	=	Mux & ((1 << REFS1) | (1 << REFS0));
    	if			(_mux == (REFADC_INT << REFADC_BITS))	etalon	/=	REFADC_INT_NOM;
    	else if	(_mux == (REFADC_EXT << REFADC_BITS))	etalon	/=	REFADC_EXT_NOM;
    	else		etalon	/=	REFADC_AVCC_NOM;
		etalon	*=	etalon_volt;

    	while(0 < Kcntr);

    	sreg			=	SREG;	
    	__disable_interrupt();
		_filter		=	filter_on;
		filter_on	=	true;
		Kflag			=	true;
		volue = GetVolue();
		Kflag			=	false;
    	SREG	=	sreg;
		filter_on	=	_filter;
		K	=	1.0;
		fvolue	=	(float)volue;
		if(((0.5 * etalon) < fvolue) && (fvolue < (1.5 * etalon)))	K	=	etalon / fvolue;
    	}
    //---------------------------------------------------------------------------------
    inline	void  Init(void)  {
      char    i;
      buffer      = (volatile  int   *)malloc((size_t)order * sizeof(int));
      for(i=0;i<order;i++)  *(buffer + i) = 0;
      }
    //---------------------------------------------------------------------------------
    inline  unsigned  char  GetMux(void)    { return  Mux;  }
    //---------------------------------------------------------------------------------
    inline  void  FilterOn(void)            { filter_on = true; }
    //---------------------------------------------------------------------------------
    inline  void  FilterOff(void)           { filter_on = false; }
    //---------------------------------------------------------------------------------
    inline  void  WriteBuffer(unsigned  int data)  {
      *(buffer + sample_cntr++) = data;
      sample_cntr %=  order;
      //	   
      if(0 < Kcntr)	Kcntr--;
      }
    //---------------------------------------------------------------------------------
    void  SetReference(unsigned char  ref)  {
      if(REFADC_AVCC  ==  ref)  {
        Mux &= ~(REFADC_MASK << REFADC_BITS);  Mux |=  (REFADC_AVCC << REFADC_BITS);
        }
      else  if(REFADC_INT  ==  ref)  {
        Mux &= ~(REFADC_MASK << REFADC_BITS);  Mux |=  (REFADC_INT << REFADC_BITS);
        }
      }
    //---------------------------------------------------------------------------------
    int GetVolue(void)  {
      			long	work;
      			int	*point;
               char  i;
      unsigned	char	sreg;

      if(filter_on) {
      	work  = 0L;	point	=	(int *)buffer;
        	for(i=0;i<order;i++)	{
        		sreg	=	SREG;	__disable_interrupt();
        		work  +=	(long)*point++;
        		SREG	=	sreg;
        		}
        	}
      else	{
        	sreg	=	SREG;	__disable_interrupt();
      	work	=	(long)*buffer;
        	SREG	=	sreg;
      	}

     	if(!Kflag)	{
	      if(Mux & (1 << ADLAR))	{
	      	if(!filter_on)	return	(int)(((float)work * ADC_SCALE_FACTOR * K) / 64.0);
	      	else				return	(int)((((float)work * ADC_SCALE_FACTOR * K) / 64.0) / (float)order);
	      	}
	      else	{
	      	if(!filter_on)	return	(int)((float)work * ADC_SCALE_FACTOR * K);
	      	else				return	(int)(((float)work * ADC_SCALE_FACTOR * K) / (float)order);
	      	}
     		}
     	else	{
	      if(Mux & (1 << ADLAR))	{
	      	if(!filter_on)	return	(int)((float)work  / 64.0);
	      	else				return	(int)(((float)work  / 64.0) / (float)order);
	      	}
	      else	{
	      	if(!filter_on)	return	(int)work;
	      	else				return	(int)((float)work / (float)order);
	      	}
     		}
      }
  };

//**************************************************************************************
class ClassADC  {
  private:
  volatile				 bool	 lock,parity,runing;
  volatile  unsigned  char  nextmux;
  public:
    ClassADCChanels *CurrADCChanel;
    ClassADCChanels *LastADCChanel;
    //---------------------------------------------------------------------------------
    ClassADC()  : lock(false), parity(false), runing(false), nextmux(0), CurrADCChanel(NULL), LastADCChanel(NULL) { }
    //---------------------------------------------------------------------------------
    void  Init(void)  {

      if(LastADCChanel !=  NULL) {
        	CurrADCChanel = LastADCChanel;
        	do  {
          	CurrADCChanel->Init();
         	CurrADCChanel = CurrADCChanel->Next;
        	} while(CurrADCChanel != LastADCChanel);
        	ADMUX		=	CurrADCChanel->Mux;
        	nextmux	=	CurrADCChanel->Next->Mux;
        	//  Start convertion
        	ADCSRA  =  (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
      	}
		}
    //---------------------------------------------------------------------------------
    void  AddChanel(ClassADCChanels *point)  {
      if(LastADCChanel  !=  NULL) {
        point->Next         = CurrADCChanel->Next;
        CurrADCChanel->Next = point;
        }
      LastADCChanel = CurrADCChanel = point;
      }
    //---------------------------------------------------------------------------------
    inline  void  GetChanelData(void)  {
      			int   data;

      if(lock)	return;
      lock	=	true;
		//	..       
		//	         
		//	        
      if(!(ADCSRA & (1 << ADSC)))	{
  			if(parity)	{
				data  			=	ADC;
  				ADMUX 			= 	nextmux;
	  	     	CurrADCChanel->WriteBuffer(data);     //      
   	  	  	CurrADCChanel 	= CurrADCChanel->Next;
     		  	nextmux 			= CurrADCChanel->Next->Mux;
     		  	}
			ADCSRA	|=	(1 << ADSC);              //  Start convertion
     		parity	^=	true;
   		}
      lock	=	false;
      }
    //---------------------------------------------------------------------------------
    inline  void  EnableInterrupt(void)   {
      if(CurrADCChanel  !=  NULL)  {
        ADMUX = nextmux;
        ADCSRA  |=  ((1 << ADIE) | (1 << ADSC));
        CurrADCChanel = CurrADCChanel->Next;
        nextmux = CurrADCChanel->Next->Mux;
        runing  = true;
        }
      }
    //---------------------------------------------------------------------------------
    inline  void  DisableInterrupt(void)  {
      ADCSRA  &=  ~(1 << ADIE);
      runing  = false;
      }
    //---------------------------------------------------------------------------------
    inline  bool  IsRuning(void)  { return  runing; }
  };

extern  ClassADC        madc,*Adc;
extern  ClassADCChanels madcChanel0,madcChanel1,madcChanel2;
extern  ClassADCChanels madcChanel3,madcChanel4,madcChanel5;

#endif  // __ADC_HPP__
