#ifndef __DISPLAY_H__
#define __DISPLAY_H__

        /* DISP_Text20x4 */
#ifdef  DISP_Text20x4 
#define DISP_MAX_X      20
#define DISP_MAX_Y      4
#define DISP_MAX_POS    (DISP_MAX_Y * DISP_MAX_X)
#else   /* DISP_Text20x4 */
#define DISP_MAX_Y      2
#define DISP_MAX_X      16
#define DISP_MAX_POS    (DISP_MAX_Y * DISP_MAX_X)
#endif  /* DISP_Text20x4 */

typedef struct _screen_ {
  volatile  WORD  old_time;
  volatile  bool  lock;
  				BYTE  pos;    		//           
  volatile  BYTE  x,y;    		//         
  volatile  BOOL  cursor_on;
  volatile  BYTE  cursor_x;		//     
  volatile  BYTE  cursor_y;
  volatile  BYTE  cursor_pos;
  volatile  BYTE  cursor_ch;
  union _data_  {
    volatile  BYTE  _2[DISP_MAX_Y][DISP_MAX_X];
    volatile  BYTE  _1[DISP_MAX_POS];
    } data;
  }  StructScreen;

#define CLRSCR          0x01
#define CUR_HOME        0x02
#define SET_MODE        0x04
#define DISPLAY_CTRL    0x08
#define SET_SHIFT       0x10
#define SET_FUNCT       0x20
#define CG_ADR_SET      0x40
#define DD_ADR_SET      0x80
/* Bits for commands */
#define INCREMENT       0x02
#define DISPLAY_SHIFT   0x01
//#define DISPLAY_SHIFT   0x08   // ???
#define DISPLAY_ON      0x04
#define CURSOR_ON       0x02
#define CURSOR_BLINK    0x01
#define RIGHT_SHIFT     0x04
#define DATA_8          0x10
#define LINES_4         0x08
#define MATRIX_5_10     0x04
#define BUSY            0x80

/***********************************************/
#define USERDEF_TABLE   0
#define HSCRLBAR_TABLE  1

int (__writechar)(int Handle, unsigned char c);
void	  _delay_mks(int  mks);	// Aey oaeoiaie ?anoiou 14.7456 MHz aey IOmega128 (aey Bolymin)
void	  _init_display(void);
void	  gotoxy(BYTE  x,BYTE y);
void	  clrscr(void);
void 	  _set_cursor_pos(BYTE  x,BYTE y);
void	  _savescr(void);
void	  _restorescr(void);
void	  _out_to_display(void);
void    _soft_cursor(void);
void    _load_defUserCharset(BYTE table);

extern	StructScreen	Screen,*saved_sreen;
#endif /* __DISPLAY_H__ */
