#ifndef __SMHPROTO_HPP__
#define __SMHPROTO_HPP__

#include  	<stdlib.h>
#include  	<string.h>
#include  	<smhcom.hpp>
#include  	<SMHLoader.hpp> 

#define 	PROT_TYPE_ONBOARD	0
#define 	PROT_TYPE_MODBUS	1

#define	PROT_MAXNUMBER		2
#define	MAXPROT_ONCOM		1
#define	PROT_MASTER       true
#define	PROT_SLAVE        false

#define   Error_Bit                   0x80
//    Slave (modbus)
#define   NO_ERROR                    0x00
#define   Error_ILLEGAL_FUNCTION      0x01  
#define   Error_ILLEGAL_DATA_ADDRESS  0x02
#define   Error_ILLEGAL_DATA_VALUE    0x03
#define   Error_SLAVE_DEVICE_FAILURE  0x04
#define   Error_ACKNOWLEDGE           0x05
#define   Error_SLAVE_DEVICE_BUSY     0x06
#define   Error_NEGATIVE_ACKNOWLEDGE  0x07
#define   Error_MEMORY_PARITY ERROR   0x08
#define   Error_NO_ANSWER_ERROR       0xFF

//  MODBUS
#define Read_Coil_Status              0x01
#define Read_Input_Status             0x02
#define Read_Holding_Registers        0x03
#define Read_Input_Registers          0x04
#define Force_Single_Coil             0x05
#define Preset_Single_Register        0x06
#define Read_Exception_Status         0x07
#define Fetch_Comm_Event_Ctr          0x0B
#define Fetch_Comm_Event_Log          0x0C
#define Programm_Controller           0x0D
#define Force_Multiple_Coils          0x0F
#define Preset_Multiple_Registers     0x10
#define Report_Slave_ID               0x11
#define Read_General_Reference        0x14
#define Write_General_Reference       0x15
#define Mask_Write_4X_Register        0x16
#define Read_Write_4X_Registers       0x17
#define Read_FIFO_Queue               0x18
#define Diagnostics                   0x08

//	    modbus
#define	Return_Query_Data               	0x0000
#define	Restart_Comm_Option             	1
#define	Return_Diagnoctic_Register      	2
#define	Force_Listen_Only_Mode          	4
#define	Clear_Ctrls_and_Diagnostic_Reg  	10
#define	Return_Bus_Message_Count        	11
#define	Return_Bus_Comm_Error_Count     	12
#define	Return_Bus_Exception_Error_Cntr 	13
#define	Return_Slave_Message_Count      	14
#define	Return_Slave_No_Response_Cntr   	15
#define	MBDIAG_Echo								Return_Query_Data
//	    SMLogix
#define	LXDIAG_ErrTicks					0x8000	//	 -   
#define	LXDIAG_Link						0x8001	//	    COM-    
#define	LXDIAG_NetAddress				0x8002	//	      
#define	LXDIAG_Clocks					0x8003	//	  ()    
															//	 clocks ( 1 clock = 69.(4)mkS)
#define	LXDIAG_ReadRAM					0x8004
#define	LXDIAG_ReadEEPROM				0x8005
#define	LXDIAG_ReadPROGR				0x8006	//	   
#define	LXDIAG_WrDebuger				0x8007	//	  
#define	LXDIAG_RdDebuger				0x8008	//	  
#define	LXDIAG_WrScreen					0x8009	//	     
#define	LXDIAG_RdScreen					0x800A	//	     
#define	LXDIAG_RdDO						0x800B	//	 DO
#define	LXDIAG_RdDI						0x800C	//	 DI
#define	LXDIAG_RdKBD					0x800D	//	 Keyboard
#define	LXDIAG_WrKBD					0x800E	//	 Keyboard
#define	LXDIAG_RdADC					0x800F	//	 ADC
#define	LXDIAG_BlockNumb		    	0x8010	//	    
                                                //     

//????? ?????? SLAVE
#define Listen_and_Do 0
#define Only_Listen   1

// 1 - ;  CRC
                          //   10 12
#define IAM_SMH2010       "\24\24\12\1\2\3\4\0\0\0\3\0\14\7\1\10\2\0\24\0" //  19
#define SIZE_IAM_SMH2010  20
#define STR_IAM           IAM_SMH2010
#define SIZE_MSG_IAM      SIZE_IAM_SMH2010

extern  __farflash  unsigned  char  CRC16[];
class ClassProtocols {
//////////////////////////////////////////////////////////////
  private:
  volatile            bool  listenOnly,lock,respError,master;
  volatile  unsigned  char  address,command,bytecounter;
  volatile  unsigned  int   startaddress,numberof;
  volatile  unsigned  int   m_size;         //     COM-
  volatile            int   responseTimeOut,tickResponseTimeOut;

  //----------------------------------------------------------
  inline	unsigned  int  modbusCRC16(unsigned char  *buff,int size)  {
    unsigned  char  bytehi,bytelo,index;
      
    bytehi  = bytelo  = 0xFF;
    while(size--) {
      bytehi  = bytelo ^ CRC16[(index = bytehi ^ *buff++) + 0x100]; //  Hi byte table
      bytelo  = CRC16[index];                                       //  Lo byte table
      }
    return  ((bytelo << 8) | bytehi);
    }
  //----------------------------------------------------------
  inline	bool  isQueryReady() {
    if(master || IsLock() || !comport->Recived)  return  false;
    return  true;
    }
  //----------------------------------------------------------
  inline	void  transmitt(unsigned  char  *mess,int  len)  {
    setCheckSumm(mess,len - 2);
    comport->SetMessage(len,mess);
    tickResponseTimeOut = responseTimeOut;
    free((void  *)mess);
    TransmittedPacket++;
    }
  //----------------------------------------------------------
  //    
  //  0x00  -   
  //  0x01  -       (error)
  //  0x02  -           (error)
  //  0x03  -      
  //  0x04  -      
  inline	unsigned  char  isResponsePresent(void) {
  comport->TestFrame();
  if(comport->Transmitted)  {   //   
    if(comport->Recived)        //   
      return  0x00;
    else  {                     //   
      if(tickResponseTimeOut <= 0)	return  0x02; //   
      else  						return  0x04; //    
      }
    }
  else  {                       //    
    if(tickResponseTimeOut <= 0)	return  0x01;    //   
    else                            return  0x03;    //    
    }
  }
//////////////////////////////////////////////////////////////////
	public:
  	ClassComs                 *comport;
  	unsigned	char		  Number;				//	    com-
	//	
  	volatile  unsigned  long  RecQuerys;          	//   
  	volatile  unsigned  long  NoResponse;         	//       
  	volatile  unsigned  long  TransmittedPacket;  	//   
  	volatile  unsigned  int   ErrorsCRC,ErrorsIFunc,ErrorsSize;
  	
  //----------------------------------------------------------
  ClassProtocols(void)  : RecQuerys(0L), \
                      NoResponse(0L), \
                      TransmittedPacket(0L), \
                      ErrorsCRC(0), \
                      ErrorsIFunc(0), \
                      ErrorsSize(0), \
                      responseTimeOut(3), \
                      listenOnly(false),\
                      lock(false),\
                      master(false),\
                      comport(NULL),\
                      Number(0)  { }
  //----------------------------------------------------------
  ClassProtocols(unsigned	char	_num)  : RecQuerys(0L), \
                      NoResponse(0L), \
                      TransmittedPacket(0L), \
                      ErrorsCRC(0), \
                      ErrorsIFunc(0), \
                      ErrorsSize(0), \
                      responseTimeOut(3), \
                      listenOnly(false),\
                      lock(false),\
                      master(false),\
                      comport(NULL)\
	                   {	Number	=	_num; }
  //----------------------------------------------------------
  ~ClassProtocols(void)	{
  		if(NULL	!=	comport)	{
  			comport->numb_prot--;
  			}
  		}
  //----------------------------------------------------------
  inline	void  Init(ClassComs *_comport)  {
    comport = _comport;
    comport->numb_prot++;
    SetSlave();
    //	PRTY = NONE, BITS = 8
    comport->Init(BAUD_115200);
    //	STOP = 2	?????????????????????
    SetStopBits(RSSTOP_2BIT);
    comport->ClrErrors();
    comport->Flush();
    

    }
	//----------------------------------------------------------
	inline	void	TurnToDefaultSlave(void)	{	
		WORD	addr;

		//	  com  EEPROM 3 
		addr	=	LXIEEA_SELFADDR0 + (3 * (int)comport->GetNumber());
        SetAddress(ieerBYTE(addr++));
		comport->SetBaudRate(ieerBYTE(addr++));
	    comport->SetStopBits(RSSTOP_2BIT);
	    comport->SetParity(PRTY_NONE);
        comport->SetFrameTimeOut(4);	//    1- 
        comport->SetByteTimeOut(3);	    //     
		SetSlave();
		}
	//----------------------------------------------------------
  	inline  __monitor bool  Lock(void)			{	if(!lock)	lock = true;	return  lock;	}
  	//----------------------------------------------------------
  	inline  __monitor void	UnLock(void)		{	lock  = false;	}
  	//----------------------------------------------------------
  	inline  __monitor bool  IsLock(void)      {	return  lock;	}
  	//----------------------------------------------------------
  	inline  __monitor void  SetMaster(void)   {	master  = true;	}
  	//----------------------------------------------------------
  	inline  __monitor void  SetSlave(void)    {	master  = false;	}
  	//----------------------------------------------------------
  	inline  bool	SetReciveBuffer(int size)					{ return  comport->SetRecBuffer(size + 9);  }  //  +  + CRC
  	//----------------------------------------------------------
  	inline  void	SetResponseTimeOut(unsigned int val)	{ responseTimeOut = val + 1;  }
  	//----------------------------------------------------------
  	inline  void            SetBaudRate(unsigned  char  baud)	{
  		comport->SetBaudRate(baud);
  		comport->SetByteTimeOut(4);		//    1- 
  		comport->SetFrameTimeOut(3);	//     
  		}
  	//----------------------------------------------------------
  	inline  void            SetParity(unsigned  char  prty)           	{ comport->SetParity(prty); }
  	//----------------------------------------------------------
  	inline  void            SetStopBits(unsigned  char  sb)              { comport->SetStopBits(sb); }
  	//----------------------------------------------------------        
  	inline  void            SetBits(unsigned  char  numb)           	   { comport->SetBits(numb); }
  	//----------------------------------------------------------
  	inline  void            SetAddress(unsigned  char  _address) {
  	 address = _address; 
  	 comport->SetCurrAddress(_address);
  	 }
  	//----------------------------------------------------------
  	inline  unsigned  char  GetAddress(void)                             { return  address;  }
  	//----------------------------------------------------------
  	inline  void            SetCommand(unsigned char  _command)          { command  = _command;  }
  	//----------------------------------------------------------
  	inline  unsigned  char  GetCommand(void)                             { return  command;  }
  	//----------------------------------------------------------
  	inline  void            SetStartAddress(unsigned  int address)       { startaddress = address; }
  	//----------------------------------------------------------
  	inline  unsigned  int   GetStartAddress(void)                        { return  startaddress; }
  	//----------------------------------------------------------
  	inline  void            SetNumberOf(unsigned  int _numberof)         { numberof  = _numberof;  }
  	//----------------------------------------------------------
  	inline  unsigned  int   GetNumberOf(void)                            { return  numberof; }
  	//----------------------------------------------------------
  	inline  void            SetByteCounter(unsigned  char _bytecounter)  { bytecounter = _bytecounter; }
  	//----------------------------------------------------------
  	inline  unsigned  char  GetByteCounter(void)                         { return bytecounter; }
  //----------------------------------------------------------
  inline	bool  testCheckSumm(unsigned char  *buff)  {
    unsigned  int *point;

    point = (unsigned int *)(buff + m_size - 2);
    if(modbusCRC16(buff,m_size - 2) == *point)  return  true;
    return  false;
    }
  //----------------------------------------------------------
  inline	void  setCheckSumm(unsigned char  *buff,unsigned  int position)  {
    unsigned  int *point;

    point   = (unsigned int *)&buff[position];
    *point  = modbusCRC16(buff,position);
    }
  //----------------------------------------------------------
  //    
	inline	void  TimeOuts(void)	{
		comport->TestFrame();
		if(comport->Transmitted && (comport->GetRecState() == RSRECS_START))	{
			if(tickResponseTimeOut > 0)	tickResponseTimeOut--;
	   	    }
		}
  //----------------------------------------------------------
  //	         
  inline  void  SendQuery(void) { 
    SetByteCounter(0);
    SendQuery(NULL);
    }
  //----------------------------------------------------------
  //	      ()  ()
  inline	void  SendQuery(unsigned  char  *buffer) {
    unsigned  char  *mess,*point;
    int len;

    len = 8;
    if(bytecounter !=  0)  len += (bytecounter  + 1);
    mess  = point = (unsigned  char *)malloc((size_t)len);
    *point++  = (unsigned char)address;
    *point++  = (unsigned char)(command & ~Error_Bit);
    *point++  = (unsigned char)(startaddress  >> 8);
    *point++  = (unsigned char)startaddress;
    *point++  = (unsigned char)(numberof  >> 8);
    *point++  = (unsigned char)numberof;
    if(0  !=  bytecounter)  {
      *point++  = bytecounter;
      memcpy(point,buffer,(int)bytecounter);
      }
    transmitt(mess,len);
    }
  //----------------------------------------------------------
  inline	bool  GetQuery(unsigned  char  **mess) {
    unsigned  char  *point;
    
	if(!isQueryReady())  return  false;
	Lock();
	m_size	=	comport->GetSizeRecMessage();
   *mess	=	point = (unsigned char  *)malloc((size_t)m_size);
   comport->GetMessage(point);

    if(*point !=  address)		{						DeleteQuery(*mess);	return  false;	}
    RecQuerys++;
    if(!testCheckSumm(point))	{	ErrorsCRC++;	DeleteQuery(*mess);	return  false;	}
    *point++;
    command	= *point++;
    
    startaddress  = (((unsigned int)*point) << 8) + (unsigned int)*(point + 1);
    numberof      = (((unsigned int)*(point + 2)) << 8) + (unsigned int)*(point + 3);
    //       (  ,  -    ..)
    switch(command) {
      case  Report_Slave_ID:
            ResponseIAM();	DeleteQuery(*mess);
				return  false;
      //     
      case  Programm_Controller:
            //     
            bytecounter = *point++;
            //       
            startaddress  = (((unsigned int)*point) << 8) + (unsigned int)*(point + 1);
            //       
            numberof      = (((unsigned int)*(point + 2)) << 8) + (unsigned int)*(point + 3);
          	return  true;
      case  Force_Single_Coil:  case  Preset_Single_Register:
				point	=	(*mess + 4);
            memmove(*mess,point,(size_t)2);
          	return true;
      case  Preset_Multiple_Registers:
      		if(numberof > 127)  			{	ResponseError();	DeleteQuery(*mess);	return	false;	}
            point = (*mess + 7);
            memmove(*mess,point,(size_t)m_size - 8);
          	return  true;
      case  Force_Multiple_Coils: 
      		if(numberof > (8 * 255))	{	ResponseError();	DeleteQuery(*mess);	return	false;	}
            point = (*mess + 7);
            memmove(*mess,point,(size_t)m_size - 8);
          	return  true;
      case  Read_Input_Registers: case  Read_Holding_Registers:
      		if(numberof > 127)  			{	ResponseError();	DeleteQuery(*mess);	return	false;	}
            free((void *)*mess);
          	return  true;
      case  Read_Input_Status:    case  Read_Coil_Status:
      		if(numberof > (8 * 255))	{	ResponseError();	DeleteQuery(*mess);	return	false;	}
            free((void *)*mess);
          	return  true;
      case	Diagnostics:
      		if(MBDIAG_Echo	==	GetStartAddress())	{	ResponseOK();	DeleteQuery(*mess);	return	false;	}
      	 	return	true;
      default:  return  true;
      }
    }
  //----------------------------------------------------------
	inline  bool  isResponseError(void) { return  respError;  }
  //----------------------------------------------------------
  //   true    
  inline	bool  GetResponse(unsigned  char  **mess) {
    unsigned	char  *point;
    BYTE              byte;
    
	 point	=	*mess	=	NULL;
    if(IsLock() || !master)  return  false;
    Lock();
    respError = true;
    switch(isResponsePresent()) {
      case  0x00: 
      				m_size =  comport->GetSizeRecMessage();
                  point = *mess	=	(unsigned char  *)malloc((size_t)m_size);
                  comport->GetMessage(point);
                  if(address	!=	*point)	return	true;
						RecQuerys++;
                  if(!testCheckSumm(point++))  {
                    ErrorsCRC++;
                    NoResponse++;
                    return  true;
                    }
                  if(command	!=	*point++)	return	true;
                  //   
                  switch(command) {
                    //     
                    case  Read_Input_Status:    case  Read_Coil_Status:
                        // 	    MODBUS       - ?
                        bytecounter = *point++;
                        byte  = numberof >> 3;
          	            if(0	!=	(numberof % 8))	 byte++;
                        if(bytecounter != byte) return	true;
                        respError     = false;
                        memmove(*mess,point,(size_t)bytecounter);
                    		break;
                    case  Read_Input_Registers:	case  Read_Holding_Registers:
                        // 	    MODBUS       - ?
                        bytecounter = *point++;
                        if(bytecounter != (numberof << 1))  return	true;
                        respError     = false;
                        memmove(*mess,point,(size_t)bytecounter);
                        break;
                    case  Diagnostics:
                  		if(MBDIAG_Echo	==	GetStartAddress())	{
                  		  point +=  2;
                  		  if(__reverse(*((WORD *)point)) != GetNumberOf())
                            return  true;
                          }
                        break;
                    }
                  respError     = false;
              		return	true;
      case  0x02:   //   
      		comport->Flush();
            NoResponse++;
            return  	true;
      case  0x01: //      
      		//	     
      		comport->Flush();
            return	true;
      case  0x03: case  0x04: default:
            UnLock();	return  false;
      }
    }
  //----------------------------------------------------------
  inline	void  ResponseIAM(void)  {
    unsigned  char  *mess,*point,len;

    len   = SIZE_MSG_IAM + 7;
    point = mess  = (unsigned char  *)malloc((size_t)len);
    memcpy((char *)(point + 5),(const char *)&STR_IAM,SIZE_MSG_IAM);
    *point++  = address;
    *point++  = command;
    *point++  = (unsigned char)(SIZE_MSG_IAM + 2);  //  Byte counter
    *point++  = *(mess + 5);                        //  Slave ID  (HI version)
    *point++  = 0xFF;                               //  ON status
    transmitt(mess,(int)len);
    }
  //----------------------------------------------------------
  inline	void  ResponseError(void) { command |=  Error_Bit; ResponseOK(); }
  //------------------------------------------------------------
  inline	void  ResponseOK(void)  {
    unsigned  char  *mess,*point;

    point     = mess    = (unsigned char  *)malloc((size_t)8);
    *point++  = address;
    *point++  = command;
    *point++  = (unsigned char)(startaddress >> 8);
    *point++  = (unsigned char)startaddress;
    *point++  = (unsigned char)(numberof >> 8);
    *point    = (unsigned char)numberof;
    transmitt(mess,8);
    }
  //----------------------------------------------------------
  inline	void  Response(unsigned  char  *message,unsigned  char  size)  {
    unsigned  char  *mess,*point;
   
    point = mess  = (unsigned char  *)malloc((size_t)((int)size + 5));
    memcpy((point + 3),message,(int)size);
    *point++  = (unsigned char)address;
    *point++  = (unsigned char)command;
    *point    = size;
    transmitt(mess,((int)size + 5));
    };
  //----------------------------------------------------------
  inline	void  DeleteQuery(unsigned  char  *mess) {
    if(mess !=  NULL) free((void *)mess);
    UnLock();
    }
  //----------------------------------------------------------
  inline	void  DeleteResponse(unsigned  char  *mess) {
    if(mess !=  NULL) free((void *)mess);
    UnLock();
    }              
  //----------------------------------------------------------
  inline	bool	CheckCRC(unsigned char  *buff,int size)	{
    unsigned  int *point;

    point = (unsigned int *)(buff + size - 2);
    if(modbusCRC16(buff,size - 2) == *point)  return  true;
    return  false;
	}
	//------------------------------------------------------------------------
   inline  void ClrErrors(void) {
  		ErrorsCRC	=	ErrorsIFunc	=	ErrorsSize	=	0;
		}
	//------------------------------------------------------------------------
   inline  void ClrStat(void) {
		RecQuerys	=	NoResponse	=	TransmittedPacket	=	0L;
		}
  // This subroutine only for kernel of SMLogix
  //----------------------------------------------------------
  inline  long            GetProgrammDataLenght(void)                 { return  (((long)startaddress << 16) | (long)numberof);  }
  //----------------------------------------------------------
  inline  unsigned  char  GetProgrammDataType(void)                   { return  GetByteCounter(); }
  };
extern	ClassProtocols		*pProtocol[2];
#endif  //  __SMHPROT_HPP__
